/*
 * gtkmonop - the gtk+ monopoly simulator
 * Copyright (C) 2001 Erik Bourget
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/* game_functions.c:  this file deals with actions to take on incoming network
   messages. parse_*() are in xml_parse.c. */

#include <stdio.h>
#include <stdlib.h>
#include <netdb.h>
#include <ctype.h>
#include <unistd.h>
#include <gtk/gtk.h>
#include <string.h>
#include <libxml/tree.h>
#include <libxml/parser.h>
#include <libxml/xmlmemory.h>

#include "structs.h"
#include "stub.h"
#include "client.h"
#include "misc_functions.h"
#include "game_functions.h"
#include "gdk_functions.h"
#include "notebook.h"
#include "xmlparse.h"

extern player *players;
extern gamelist *gameslist;

void monopd_inmessage (enum inmsg_type msgtype, xmlDocPtr doc, xmlNodePtr node, int sock) 
{
	extern GtkWidget *mainwin;
	extern int connected;
	GtkWidget *temp;
	
	char *str;
	
	switch(msgtype) {
		
	case IN_CLIENT:
		parse_client(doc, node);
		break;
		
	case IN_CONNECTED:
		/* send nick */
		temp = gtk_object_get_data(GTK_OBJECT(mainwin), "connectstatuslabel");
		gtk_label_set(GTK_LABEL(temp), "Connected to server.");
		
		temp = gtk_object_get_data(GTK_OBJECT(mainwin), "nickentry");
		str = gtk_editable_get_chars(GTK_EDITABLE(temp), 0, -1);
		client_outmessage(OUT_NICK, str);
		g_free(str);
		connected = 1;
		connectdialog_connected();
		
		break;
		
		//	case IN_PLAYERLIST:
		// players = parse_playerlist(doc, node);
		// update_board();
		// break;

	case IN_ENDTRANSMISSION:
		break;
		
	case IN_GAMELIST:
		parse_gamelist(doc, node);
		update_gamelist();
		break;
		
	case IN_UPDATEGAMELIST:
		parse_updategamelist(doc, node);
		update_gamelist();
		break;
		
	case IN_UPDATEPLAYERLIST:
		parse_updateplayerlist(doc, node);
		update_board();
		break;

	case IN_PLAYERUPDATE:
		parse_playerupdate(doc, node);
		update_board();
		update_statusbar();
		break;

		/*
		  case IN_JOINEDGAME:
		  prefs->me = parse_joinedgame(doc, node);
		  break;
		*/ 

	case IN_LEFTGAME:
		parse_leftgame(doc, node);
		update_board();
		break;

	case IN_MSG:
		parse_msg(doc, node);
		break;
		
	case IN_NEWTURN:
		parse_newturn(doc, node);
		break;
		
	case IN_ESTATEUPDATE:
		parse_estateupdate(doc, node);
		break;
	case IN_TRADEUPDATE:
		parse_tradeupdate(doc, node);
		break;
		
	case IN_AUCTIONUPDATE:
		parse_auctionupdate(doc, node);
		break;
		
	case IN_COMMANDLIST:
	default:
		
		
	}
}

	
